/*
 * UPIWIN - Micro Pi Windowing Framework Kernel
 * Copyright (C) 2019 Amy Bowersox/Erbosoft Metaverse Design Solutions
 *    
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *    
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *-------------------------------------------------------------------------
 */
#include <stdlib.h>
#include <string.h>
#include "bitmap.h"

PBITMAP BMP_Create(INT32 width, INT32 height, const void *bits)
{
  PBITMAP rc;
  UINT32 tot_size = sizeof(BITMAP) + (width * height * sizeof(UINT16));

  rc = (PBITMAP)malloc(tot_size);
  if (!rc)
    return NULL;
  memset(rc, 0, tot_size);
  _Go_init(&(rc->hdr), BMP_SIG_WORD, tot_size);
  rc->width = width;
  rc->height = height;
  if (bits)
    memcpy(rc->bits, bits, width * height * sizeof(UINT16));
  return rc;
}

void BMP_Delete(PBITMAP pbmp)
{
  Go_release(&(pbmp->hdr));
}
